<template>
    <div class="promo-row">
        <div class="box-table-element" v-for="promo in promos">
            <promo-details-modal :promo="promo"/>
            <p class="name-blue">{{ promo.name }}</p>
            <p class="b-v">{{ $t('promos.pages.table.invested') }} <span>$ {{ promo.invested | formatAmount}}</span></p>
            <p class="text-grey-opacity">{{ $t('promos.pages.table.income') }} <span>$ {{ promo.income | formatAmount }}</span></p>
            <profit-help>
                <span :class="{'color-green' : promo.profit >= 0}">$ {{ promo.profit | formatAmount }} ( % {{ Number.parseFloat(promo.profit_percent).toFixed(2) }})</span>
            </profit-help>
            <p class="text-grey-opacity">{{ $t('promos.pages.table.structure') }} {{ promo.structure }} {{ $t('ui.people') }}</p>
            <div class="box-icon">
                <svg class="edit blue" @click="editPromo(promo)">
                    <use xlink:href="/img/sprite.svg#edit"></use>
                </svg>
                <svg class="delete" @click="deletePromo(promo)">
                    <use xlink:href="/img/sprite.svg#cancel-button"></use>
                </svg>

            </div>
        </div>
		<transition name="modal-slide">
			<edit-modal v-if="edit_modal_opened" :type="type" @close="close"
						  @reload="reload" :promo="editable_promo"/>
		</transition>
        <paginator
            :current-page="currentPage"
            :last-page="lastPage"
            :per-page="perPage"
            :items-count="total"
            @page-changed="setPage"
        />
    </div>
</template>

<script>
	import {mapGetters} from "vuex";
    import ProfitHelp from "./ProfitHelp";
    import PromoDetailsModal from "./PromoDetailsModal";
    import EditModal from "./EditModal";
	import currencies from "../../currencies";

    export default {
		name: "PromosTable",
        props: ['search', 'type'],
        data(){
            return {
                currentPage: 0,
                lastPage: 0,
                perPage: 0,
                total: 0,
                page: 1,
                promos: [],
				edit_modal_opened: false,
				editable_promo: null
            }
        },
		filters: {
			formatAmount(value){
				return currencies.formatAmount(value);
			}
		},
        computed: {
            ...mapGetters([
                'axios'
            ])
        },
        watch: {
            search(val){
                this.submit();
            },
        },
        methods: {
            submit(){
                this.axios
                    .get('promos', {
                        params: {
                            search: this.search,
                            type: this.type,
                            page: this.page
                        }
                    })
                    .then(resp => resp.data)
                    .then(promos => {
                        console.log(promos);
                        this.currentPage = promos.current_page;
                        this.lastPage = promos.last_page;
                        this.perPage = promos.per_page;
                        this.total = promos.total;
                        this.promos = promos.data;
                    });
            },
            deletePromo(promo){
                this.axios
                    .post(`promos/${promo.id}/delete`)
                    .then(resp => resp.data)
                    .then(data => {
                        if('success' === data.status){
                            this.$swal(this.$t('ui.deleted'), '', 'success');
                            this.submit()
                        }else{
                            this.$swal(this.$t('ui.error'), '', 'error');
                        }
                    });
            },
			editPromo(promo){
				this.edit_modal_opened = true;
				this.editable_promo = promo;
			},
			close(){
				this.edit_modal_opened = false;
				this.editable_promo = null;
			},
			reload(){
				this.$emit('reload');
			},
            formatDate(date){
                return this.$date(date).format('DD.MM.YYYY');
            },
            setPage(page){
                this.page = page;
                this.submit();
            },
        },
        created(){
            this.submit();
        },
        components: {
		    ProfitHelp,
            PromoDetailsModal,
			EditModal,
        }
	}
</script>

<style scoped lang="scss">
.box-table-element .box-info-profit .profit span.color-green{
	color: #3cc32f;
}
.box-modalPlus {
	max-height: 1000px;
	overflow: hidden;
	left: 50%;
	transform: translate(-50%, 0);
	right: unset;
}

.modal-slide-enter-ative, .modal-slide-leave-active {
	transition: max-height 0.8s ease;
}

.modal-slide-enter, .modal-slide-leave-to {
	max-height: 0px;
}
</style>
